﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace XamOrgChart
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Department> data;
        public MainWindow()
        {
            InitializeComponent();
            data = new DepartmentViewModel().Departments;
            this.DataContext = data;
        }
    }

    public class Department
    {
        public Department(string name)
        {
            this.Name = name;
            this.EmployeePositions = new ObservableCollection<EmployeePosition>();
        }

        public string Name { get; set; }
        public ObservableCollection<EmployeePosition> EmployeePositions { get; set; }
    }

    public class EmployeePosition
    {
        public EmployeePosition(string jobTitle)
        {
            this.JobTitle = jobTitle;
            this.Employees = new ObservableCollection<Employee>();
        }

        public string JobTitle { get; set; }
        public ObservableCollection<Employee> Employees { get; set; }
    }

    public class Employee
    {
        public Employee(string firstName, string lastName, string jobTitle)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
            this.JobTitle = jobTitle;
        }

        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string JobTitle { get; set; }
    }

    public class DepartmentViewModel
    {
        public ObservableCollection<Department> Departments { get; set; }

        public DepartmentViewModel()
        {
            Employee employee1 = new Employee("Rob", "Walters", "Senior Tool Designer");
            Employee employee2 = new Employee("Ovidiu", "Cracium", "Senior Tool Designer");
            Employee employee3 = new Employee("Thierry", "D'Hers", "Tool Designer");
            Employee employee4 = new Employee("Janice", "Galvin", "Tool Designer");

            EmployeePosition position1 = new EmployeePosition("Senior Tool Designer");
            position1.Employees.Add(employee1);
            position1.Employees.Add(employee2);

            EmployeePosition position2 = new EmployeePosition("Tool Designer");
            position2.Employees.Add(employee3);
            position2.Employees.Add(employee4);

            Department department1 = new Department("Tool Design");
            department1.EmployeePositions.Add(position1);
            department1.EmployeePositions.Add(position2);

            this.Departments = new ObservableCollection<Department>();
            this.Departments.Add(department1);
        }
    }

}
